/*******************************************************
 *  Unit test for the date class
 *
 * test date add and subtract expressions
 ******************************************************
 *
 */

#include "date.h"
#include <assert.h>

int main()
{
   date   d0(9, 6, 2019);
   date   period0(5, 3, 6);

   date d1;
   date d2;
   d2 = d0 + period0;

   std::cout << d0 << " + " << period0 << " = " << d2 << "\n";
   assert(d2 == date(14, 9, 2025));

   date    period1(30, 11, 3);   // 3 years, 11 months and 30 days
   d2 = d0 + period1;
   std::cout << d0 << " + " << period1 << " = " << d2 << "\n";
   assert(d2 == date(8, 6, 2023));

   long   days = 365;
   d2 = d0 + days;
   std::cout << d0 << " + " << days << " days = " << d2 << "\n";
   assert(d2 == date(8, 6, 2020));    //  2020 is a leapyear

   d1 = date(22, 7, 2019);
   std::cout << d1 << " += " << days << " = ";
   d1 += days;
   std::cout << d1 << "\n";
   assert(d1 == date(21, 7, 2020));

   d1 = date(28, 2, 2020);
   std::cout << d1 << " ++  = ";
   d1++;                            // postfix
   std::cout << d1 << "\n";
   assert(d1 == date(29, 2, 2020));
   std::cout << "++ " << d1;
   ++d1;                            // prefix
   std::cout << " = " << d1 << "\n";
   assert(d1 == date(1, 3, 2020));

   d2 = date(8, 6, 2020);
   days = d2 - d0;
   std::cout << d2 << " - " << d0 << " = " << days << " days\n";
   assert(days == 365);

   d2 = date(8, 6, 2020);
   days = 365;
   d1 = d2 - days;
   std::cout << d2 << " - " << days << " days = " << d1 << "\n";
   assert(d1 == date(9, 6, 2019));    //  2020 is a leapyear

   d1 = date(22, 7, 2020);
   days = 365;
   std::cout << d1 << " -= " << days << " = ";
   d1 -= days;
   std::cout << d1 << "\n";
   assert(d1 == date(23, 7, 2019));

   d1 = date(1, 3, 2020);
   std::cout << d1 << " --  = ";
   d1--;                            // postfix
   std::cout << d1 << "\n";
   assert(d1 == date(29, 2, 2020));
   std::cout << "-- " << d1;
   --d1;                            // prefix
   std::cout << " = " << d1 << "\n";
   assert(d1 == date(28, 2, 2020));

   return 0;
}

