/*******************************************************
 *  Unit test for the hour class
 *
 * test contrustor and assignment of hour objects
 ******************************************************
 *
 */

#include "date.h"
#include <assert.h>

int main()
{
   // Default contructor: all zero
   hour h0;

   std::cout << "The default contructor makes a zero hour: \"" << h0 << "\"\n";
   assert(h0.Hour() == 0);
   assert(h0.Minute() == 0);
   assert(h0.Second() == 0);

   hour h1(15, 20, 45);

   std::cout << "Contructor with hour = 15 minure = 20, and second = 45: \"" << h1 << "\"\n";
   assert(h1.Hour() == 15);
   assert(h1.Minute() == 20);
   assert(h1.Second() == 45);

   hour h2(88, 55, 1000);

   std::cout << "Contructor with hour = 88 minute = 55, and second = 1000: \"" << h2 << "\"\n";
   assert(h2.Hour() == 88);
   assert(h2.Minute() == 55);
   assert(h2.Second() == 1000);

   // The copy constructor is just a bitwise copy

   hour h3(h1);

   std::cout << "Copy contructor from " << h1 << ": \"" << h3 << "\"\n";
   assert(h3.Hour() == 15);
   assert(h3.Minute() == 20);
   assert(h3.Second() == 45);

   // Also assignment is just a bitwise copy

   hour h4;

   h4 = h1;
   std::cout << "Assigned from " << h1 << ": \"" << h4 << "\"\n";
   assert(h4.Hour() == 15);
   assert(h4.Minute() == 20);
   assert(h4.Second() == 45);

   return 0;
}

