/*******************************************************
 *  Unit test for the String class
 *
 * test basic string operations
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

int main()
{
   // Default contructor: empty string
   String s0;

   std::cout << "The default contructor makes an empty string: \"" << s0 << "\"\n";
   assert(~s0 == 0);

   // The length of a string with the ~ operator
   String s1("abcde");
   int    length;

   // check boolean opareations that check for empty strings

   if (s0)
   {
      std::cout << "\"" << s0 << "\" is not empty.\n";
   }
   else
   {
      std::cout << "\"" << s0 << "\" is empty.\n";
   }
   if (!s0)
   {
      std::cout << "\"" << s0 << "\" is empty.\n";
   }
   else
   {
      std::cout << "\"" << s0 << "\" is not empty.\n";
   }

   if (s1)
   {
      std::cout << "\"" << s1 << "\" is not empty.\n";
   }
   else
   {
      std::cout << "\"" << s1 << "\" is empty.\n";
   }
   if (!s1)
   {
      std::cout << "\"" << s1 << "\" is empty.\n";
   }
   else
   {
      std::cout << "\"" << s1 << "\" is not empty.\n";
   }

   length = ~s1;
   std::cout << "The length of \"" << s1 << "\" is " << length << "\n";
   assert(length == 5);

   // test character access, also outside boundaries (e.g. -1, 666)

   char c;
   c = s1[0];
   std::cout << "First character of " << s1 << " '" << c << "'\n";
   assert(c == 'a');
   c = s1[3];
   std::cout << "Fourth character of " << s1 << " '" << c << "'\n";
   assert(c == 'd');

   // Out of bounds
   //c = s1[-1];
   //std::cout << "Seventh character of " << s1 << " char(" << (int)c << ")\n";
   //assert(c == 'a');

   s1[2] = 'Z';
   std::cout << "After \"abcde\"[2] = 'Z' : " << s1 << "\n";
   assert(s1 == "abZde");

   s1[5] = 'X';
   std::cout << "After \"abcde\"[5] = 'X' : " << s1 << "\n";
   //assert(s1 == "abZde");

   return 0;
}

