/*******************************************************
 *  Unit test for the UTC class
 *
 * test UTC add and subtract expressions
 ******************************************************
 *
 */

#include "date.h"
#include <assert.h>

int main()
{
   date   d0(9, 6, 2019);
   hour   t0;
   UTC    period0(date(5, 3, 6), t0);

   UTC u0(d0, t0);
   UTC d1;
   UTC d2;
   d2 = u0 + period0;

   std::cout << u0 << " + " << period0 << " = " << d2 << "\n";
   assert(d2 == UTC(date(14, 9, 2025), t0));

   UTC    period1(date(30, 11, 3), t0);   // 3 years, 11 months and 30 days
   d2 = u0 + period1;
   std::cout << u0 << " + " << period1 << " = " << d2 << "\n";
   assert(d2 == UTC(date(8, 6, 2023), t0));

   d1 = UTC(date(22, 7, 2019), t0);
   std::cout << d1 << " += " << period1 << " = ";
   d1 += period1;
   std::cout << d1 << "\n";
   std::cout.flush();
   assert(d1 == UTC(date(22, 7, 2023), t0));

   return 0;
}

